# coding: utf-8

"""
    DLCM-Solution

    DLCM application wrapping all modules, All-In-One  # noqa: E501

    The version of the OpenAPI document: 2.1.1
    Contact: eresearch-opensource@unige.ch
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from dlcmapi_client.configuration import Configuration


class OaiSet(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'links': 'object',
        'creation': 'ChangeInfo',
        'description': 'str',
        'enabled': 'bool',
        'last_update': 'ChangeInfo',
        'name': 'str',
        'query': 'str',
        'res_id': 'str',
        'spec': 'str'
    }

    attribute_map = {
        'links': '_links',
        'creation': 'creation',
        'description': 'description',
        'enabled': 'enabled',
        'last_update': 'lastUpdate',
        'name': 'name',
        'query': 'query',
        'res_id': 'resId',
        'spec': 'spec'
    }

    def __init__(self, links=None, creation=None, description=None, enabled=None, last_update=None, name=None, query=None, res_id=None, spec=None, local_vars_configuration=None):  # noqa: E501
        """OaiSet - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._links = None
        self._creation = None
        self._description = None
        self._enabled = None
        self._last_update = None
        self._name = None
        self._query = None
        self._res_id = None
        self._spec = None
        self.discriminator = None

        if links is not None:
            self.links = links
        if creation is not None:
            self.creation = creation
        if description is not None:
            self.description = description
        if enabled is not None:
            self.enabled = enabled
        if last_update is not None:
            self.last_update = last_update
        if name is not None:
            self.name = name
        if query is not None:
            self.query = query
        if res_id is not None:
            self.res_id = res_id
        if spec is not None:
            self.spec = spec

    @property
    def links(self):
        """Gets the links of this OaiSet.  # noqa: E501

        The _links_ list of the _oai-sets_ resource  # noqa: E501

        :return: The links of this OaiSet.  # noqa: E501
        :rtype: object
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this OaiSet.

        The _links_ list of the _oai-sets_ resource  # noqa: E501

        :param links: The links of this OaiSet.  # noqa: E501
        :type: object
        """

        self._links = links

    @property
    def creation(self):
        """Gets the creation of this OaiSet.  # noqa: E501


        :return: The creation of this OaiSet.  # noqa: E501
        :rtype: ChangeInfo
        """
        return self._creation

    @creation.setter
    def creation(self, creation):
        """Sets the creation of this OaiSet.


        :param creation: The creation of this OaiSet.  # noqa: E501
        :type: ChangeInfo
        """

        self._creation = creation

    @property
    def description(self):
        """Gets the description of this OaiSet.  # noqa: E501

        The description of the OAI set  # noqa: E501

        :return: The description of this OaiSet.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this OaiSet.

        The description of the OAI set  # noqa: E501

        :param description: The description of this OaiSet.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def enabled(self):
        """Gets the enabled of this OaiSet.  # noqa: E501

        If the OAI set is enable  # noqa: E501

        :return: The enabled of this OaiSet.  # noqa: E501
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """Sets the enabled of this OaiSet.

        If the OAI set is enable  # noqa: E501

        :param enabled: The enabled of this OaiSet.  # noqa: E501
        :type: bool
        """

        self._enabled = enabled

    @property
    def last_update(self):
        """Gets the last_update of this OaiSet.  # noqa: E501


        :return: The last_update of this OaiSet.  # noqa: E501
        :rtype: ChangeInfo
        """
        return self._last_update

    @last_update.setter
    def last_update(self, last_update):
        """Sets the last_update of this OaiSet.


        :param last_update: The last_update of this OaiSet.  # noqa: E501
        :type: ChangeInfo
        """

        self._last_update = last_update

    @property
    def name(self):
        """Gets the name of this OaiSet.  # noqa: E501

        The name of the OAI set  # noqa: E501

        :return: The name of this OaiSet.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this OaiSet.

        The name of the OAI set  # noqa: E501

        :param name: The name of this OaiSet.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def query(self):
        """Gets the query of this OaiSet.  # noqa: E501

        The query of the OAI set  # noqa: E501

        :return: The query of this OaiSet.  # noqa: E501
        :rtype: str
        """
        return self._query

    @query.setter
    def query(self, query):
        """Sets the query of this OaiSet.

        The query of the OAI set  # noqa: E501

        :param query: The query of this OaiSet.  # noqa: E501
        :type: str
        """

        self._query = query

    @property
    def res_id(self):
        """Gets the res_id of this OaiSet.  # noqa: E501

        The _oai-sets_ resource identifier [https://en.wikipedia.org/wiki/Universally_unique_identifier[UUID]]  # noqa: E501

        :return: The res_id of this OaiSet.  # noqa: E501
        :rtype: str
        """
        return self._res_id

    @res_id.setter
    def res_id(self, res_id):
        """Sets the res_id of this OaiSet.

        The _oai-sets_ resource identifier [https://en.wikipedia.org/wiki/Universally_unique_identifier[UUID]]  # noqa: E501

        :param res_id: The res_id of this OaiSet.  # noqa: E501
        :type: str
        """

        self._res_id = res_id

    @property
    def spec(self):
        """Gets the spec of this OaiSet.  # noqa: E501

        The specification of the OAI set  # noqa: E501

        :return: The spec of this OaiSet.  # noqa: E501
        :rtype: str
        """
        return self._spec

    @spec.setter
    def spec(self, spec):
        """Sets the spec of this OaiSet.

        The specification of the OAI set  # noqa: E501

        :param spec: The spec of this OaiSet.  # noqa: E501
        :type: str
        """

        self._spec = spec

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OaiSet):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, OaiSet):
            return True

        return self.to_dict() != other.to_dict()
